Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/dimension.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/dimension.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/dimension.f90	(revision 5213)
@@ -8,18 +8,35 @@
 !> @brief 
 !> This module manage dimension and how to change order of those dimension.
-!
+!>
 !> @details
 !>    define type TDIM:<br/>
-!>    TYPE(TDIM) :: tl_dim<br/>
-!>
-!>    to initialise a dimension structure:<br/>
-!>    - tl_dim=dim_init( cd_name, [id_len,] [ld_uld,] [cd_sname])
+!> @code
+!>    TYPE(TDIM) :: tl_dim
+!> @endcode
+!>
+!>    to initialize a dimension structure:<br/>
+!> @code
+!>    tl_dim=dim_init( cd_name, [id_len,] [ld_uld,] [cd_sname])
+!> @endcode
 !>       - cd_name is the dimension name
-!>       - id_len is the dimension size (optional)
-!>       - ld_uld is true if this dimension is the unlimited one (optional)
-!>       - cd_sname is the dimension short name (optional)
+!>       - id_len is the dimension size [optional]
+!>       - ld_uld is true if this dimension is the unlimited one [optional]
+!>       - cd_sname is the dimension short name ('x','y','z','t') [optional]
+!>
+!>    to clean dimension structure:<br/>
+!> @code
+!>    CALL dim_clean(tl_dim)
+!> @endcode
+!>       - tl_dim : dimension strucutre or array of dimension structure
 !>
 !>    to print information about dimension structure:<br/>
+!> @code
 !>    CALL dim_print(tl_dim)
+!> @endcode
+!>
+!>    to copy dimension structure in another one (using different memory cell):<br/>
+!> @code
+!>    tl_dim2=dim_copy(tl_dim1) 
+!> @endcode
 !>
 !>    to get dimension name:<br/>
@@ -35,8 +52,8 @@
 !>    - tl_dim\%l_uld
 !>
-!>    to get dimension id (use for variable or file dimension):<br/>
+!>    to get dimension id (for variable or file dimension):<br/>
 !>    - tl_dim\%i_id 
 !>
-!>    to know if dimension is used (use for variable or file dimension):<br/>
+!>    to know if dimension is used (for variable or file dimension):<br/>
 !>    - tl_dim\%l_use
 !>
@@ -44,55 +61,97 @@
 !>    variables as well as files use usually 4 dimensions.<br/>
 !>    To easily work with variable we want they will be all 4D and ordered as
-!>    follow: ('x','y','z','t').<br/>
+!>    following: ('x','y','z','t').<br/>
 !>    Functions and subroutines below, allow to reorder dimension of 
 !>    variable.<br/>
 !>    
-!>    Suppose we defined the table of dimension structure below:<br/>
-!>    TYPE(TDIM), DIMENSION(4) :: tl_dim
+!>    Suppose we defined the array of dimension structure below:<br/>
+!> @code
+!>    TYPE(TDIM), DIMENSION(4) :: tl_dim 
 !>    tl_dim(1)=dim_init( 'X', id_len=10)
 !>    tl_dim(2)=dim_init( 'T', id_len=3, ld_uld=.TRUE.)
-!>
-!>    to reorder dimension as we assume variable are defined
-!>    ('x','y','z','t'):<br/>
-!>    CALL dim_reorder(tl(dim(:))
+!> @endcode
+!>
+!>    to reorder dimension (default order: ('x','y','z','t')):<br/>
+!> @code
+!>    CALL dim_reorder(tl_dim(:))
+!> @endcode
 !>
 !>    This subroutine filled dimension structure with unused dimension, 
-!>    then switch from "unordered" dimension to "ordered" dimension
-!>    The dimension structure return will be:
-!>    tl_dim(1) => 'X', i_len=10, l_use=T, l_uld=F
-!>    tl_dim(2) => 'Y', i_len=0,  l_use=F, l_uld=F 
-!>    tl_dim(3) => 'Z', i_len=0,  l_use=F, l_uld=F
-!>    tl_dim(4) => 'T', i_len=3,  l_use=T, l_uld=T
-!>
-!>    After using dim_reorder subroutine you could use functions and subroutine
+!>    then switch from "unordered" dimension to "ordered" dimension.<br/>
+!>    The dimension structure return will be:<br/>
+!>    tl_dim(1) => 'X', i_len=10, l_use=T, l_uld=F<br/>
+!>    tl_dim(2) => 'Y', i_len=1,  l_use=F, l_uld=F<br/> 
+!>    tl_dim(3) => 'Z', i_len=1,  l_use=F, l_uld=F<br/>
+!>    tl_dim(4) => 'T', i_len=3,  l_use=T, l_uld=T<br/>
+!>
+!>    After using subroutine dim_reorder you could use functions and subroutine
 !>    below.<br/>
 !>
-!>    to reshape table of value in "ordered" dimension:<br/>
+!>    to use another dimension order.<br/>
+!> @code
+!>    CALL dim_reorder(tl(dim(:), cl_neworder)
+!> @endcode
+!>    - cl_neworder : character(len=4) (example: 'yxzt')
+!>
+!>    to switch dimension array from ordered dimension to unordered
+!> dimension:<br/>
+!> @code
+!>    CALL dim_unorder(tl_dim(:))
+!> @endcode
+!>
+!>    to fill unused dimension of an array of dimension structure.<br/>
+!> @code
+!>    tl_dimout(:)=dim_fill_unused(tl_dimin(:))
+!> @endcode
+!>    - tl_dimout(:) : 1D array (4elts) of dimension strcuture
+!>    - tl_dimin(:)  : 1D array (<=4elts) of dimension structure
+!>
+!>    to reshape array of value in "ordered" dimension:<br/>
+!> @code
 !>    CALL dim_reshape_2xyzt(tl_dim(:), value(:,:,:,:))
-!>       - value must be a 4D table of real(8) value "unordered"
-!>
-!>    to reshape table of value in "unordered" dimension:<br/>
+!> @endcode
+!>       - value must be a 4D array of real(8) value "unordered"
+!>
+!>    to reshape array of value in "unordered" dimension:<br/>
+!> @code
 !>    CALL dim_reshape_xyzt2(tl_dim(:), value(:,:,:,:))
-!>       - value must be a 4D table of real(8) value "ordered"
-!>
-!>    to reorder a 1D table of 4 elements in "ordered" dimension:<br/>
+!> @endcode
+!>       - value must be a 4D array of real(8) value "ordered"
+!>
+!>    to reorder a 1D array of 4 elements in "ordered" dimension:<br/>
+!> @code
 !>    CALL dim_reorder_2xyzt(tl_dim(:), tab(:))
-!>
-!>       - tab must be a 1D table with 4 elements "unordered".
+!> @endcode
+!>       - tab must be a 1D array with 4 elements "unordered".
 !>       It could be composed of character, integer(4), or logical
 !> 
-!>    to reorder a 1D table of 4 elements in "unordered" dimension:<br/>
+!>    to reorder a 1D array of 4 elements in "unordered" dimension:<br/>
+!> @code
 !>    CALL dim_reorder_2xyzt(tl_dim(:), tab(:))
-!>
-!>       - tab must be a 1D table with 4 elements "ordered".
+!> @endcode
+!>       - tab must be a 1D array with 4 elements "ordered".
 !>       It could be composed of character, integer(4), or logical
 !>
-!> @author
-!> J.Paul
+!>    to get dimension index from a array of dimension structure, 
+!>    given dimension name or short name :<br/>
+!> @code
+!>    index=dim_get_index( tl_dim(:), [cl_name, cl_sname] )
+!> @endcode
+!>       - tl_dim(:) : array of dimension structure
+!>       - cl_name : dimension name [optional]
+!>       - cl_sname: dimension short name [optional]
+!>
+!>    to get dimension id used in an array of dimension structure, 
+!>    given dimension name or short name :<br/>
+!> @code
+!>    id=dim_get_id( tl_dim(:), [cl_name, cl_sname] )
+!> @endcode
+!>       - tl_dim(:) : array of dimension structure
+!>       - cl_name : dimension name [optional]
+!>       - cl_sname: dimension short name [optional]
+!>
+!> @author J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!
-!> @todo
-!> - add description generique de l'objet dim
+!> @date November, 2013 - Initial Version
 !>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -104,11 +163,8 @@
    USE fct                             ! basic useful function
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
    ! type and variable
    PUBLIC :: TDIM              !< dimension structure
-   PUBLIC :: ip_maxdim         !< number of dimension to be used
-   PUBLIC :: cp_dimorder       !< dimension order
 
    ! function and subroutine
@@ -116,94 +172,164 @@
    PUBLIC :: dim_clean         !< clean dimension structuree
    PUBLIC :: dim_print         !< print dimension information
-   PUBLIC :: dim_get_id        !< get dimension id in table of dimension structure
-   PUBLIC :: dim_get_void_id   !< get unused dimension id in table of dimension structure
-   PUBLIC :: dim_order         !< check if dimension are ordered or not
+   PUBLIC :: dim_copy          !< copy dimension structure
    PUBLIC :: dim_reorder       !< filled dimension structure to switch from unordered to ordered dimension
-   PUBLIC :: dim_unorder       !< switch dimension table from ordered to unordered dimension
-   PUBLIC :: dim_reshape_2xyzt !< reshape table dimension to ('x','y','z','t')
-   PUBLIC :: dim_reshape_xyzt2 !< reshape table dimension from ('x','y','z','t')
-   PUBLIC :: dim_reorder_2xyzt !< reorder 1D table to ('x','y','z','t')
-   PUBLIC :: dim_reorder_xyzt2 !< reorder 1D table from ('x','y','z','t')
-
-   PRIVATE :: dim__fill_unused      !< filled dimension structure with unused dimension 
-   PRIVATE :: dim__reshape_2xyzt_dp !< reshape real(8) 4D table to ('x','y','z','t')
-   PRIVATE :: dim__reshape_xyzt2_dp !< reshape real(8) 4D table from ('x','y','z','t')
-   PRIVATE :: dim__reorder_2xyzt_i4 !< reorder integer(4) 1D table to ('x','y','z','t')
-   PRIVATE :: dim__reorder_xyzt2_i4 !< reorder integer(4) 1D table from ('x','y','z','t')
-   PRIVATE :: dim__reorder_2xyzt_l  !< reorder logical 1D table to ('x','y','z','t')
-   PRIVATE :: dim__reorder_xyzt2_l  !< reorder logical 1D table from ('x','y','z','t')
-   PRIVATE :: dim__reorder_2xyzt_c  !< reorder string 1D table to ('x','y','z','t')
-   PRIVATE :: dim__reorder_xyzt2_c  !< reorder string 1D table from ('x','y','z','t')
-   PRIVATE :: dim__clean_unit       !< clean one dimension structure
-   PRIVATE :: dim__clean_tab        !< clean a table of dimension structure
-   PRIVATE :: dim__print_unit       !< print information on one dimension structure
-   PRIVATE :: dim__print_tab        !< print information on a table of dimension structure
-
-   !> @struct TDIM
-   TYPE TDIM
-      CHARACTER(LEN=lc) :: c_name = ''!< dimension name
+   PUBLIC :: dim_unorder       !< switch dimension array from ordered to unordered dimension
+   PUBLIC :: dim_fill_unused   !< filled dimension structure with unused dimension 
+   PUBLIC :: dim_reshape_2xyzt !< reshape array dimension to ('x','y','z','t')
+   PUBLIC :: dim_reshape_xyzt2 !< reshape array dimension from ('x','y','z','t')
+   PUBLIC :: dim_reorder_2xyzt !< reorder 1D array to ('x','y','z','t')
+   PUBLIC :: dim_reorder_xyzt2 !< reorder 1D array from ('x','y','z','t')
+   PUBLIC :: dim_get_index     !< get dimension index in array of dimension structure
+   PUBLIC :: dim_get_id        !< get dimension id in array of dimension structure
+
+   PRIVATE :: dim__reshape_2xyzt_dp ! reshape real(8) 4D array to ('x','y','z','t')
+   PRIVATE :: dim__reshape_xyzt2_dp ! reshape real(8) 4D array from ('x','y','z','t')
+   PRIVATE :: dim__reorder_2xyzt_i4 ! reorder integer(4) 1D array to ('x','y','z','t')
+   PRIVATE :: dim__reorder_xyzt2_i4 ! reorder integer(4) 1D array from ('x','y','z','t')
+   PRIVATE :: dim__reorder_2xyzt_l  ! reorder logical 1D array to ('x','y','z','t')
+   PRIVATE :: dim__reorder_xyzt2_l  ! reorder logical 1D array from ('x','y','z','t')
+   PRIVATE :: dim__reorder_2xyzt_c  ! reorder string 1D array to ('x','y','z','t')
+   PRIVATE :: dim__reorder_xyzt2_c  ! reorder string 1D array from ('x','y','z','t')
+   PRIVATE :: dim__clean_unit       ! clean one dimension structure
+   PRIVATE :: dim__clean_arr        ! clean a array of dimension structure
+   PRIVATE :: dim__print_unit       ! print information on one dimension structure
+   PRIVATE :: dim__print_arr        ! print information on a array of dimension structure
+   PRIVATE :: dim__copy_unit        ! copy dimension structure
+   PRIVATE :: dim__copy_arr         ! copy array of dimension structure
+
+   TYPE TDIM !< dimension structure
+      CHARACTER(LEN=lc) :: c_name = ''       !< dimension name
       CHARACTER(LEN=lc) :: c_sname = 'u'     !< dimension short name
-      INTEGER(i4)       :: i_id = 0          !< dimension id
+      INTEGER(i4)       :: i_id  = 0         !< dimension id
       INTEGER(i4)       :: i_len = 1         !< dimension length
       LOGICAL           :: l_uld = .FALSE.   !< dimension unlimited or not
       LOGICAL           :: l_use = .FALSE.   !< dimension used or not
-      INTEGER(i4)       :: i_2xyzt = 0       !< indices to reshape table to ('x','y','z','t')
-      INTEGER(i4)       :: i_xyzt2 = 0       !< indices to reshape table from ('x','y','z','t')
+      INTEGER(i4)       :: i_2xyzt = 0       !< indices to reshape array to ('x','y','z','t')
+      INTEGER(i4)       :: i_xyzt2 = 0       !< indices to reshape array from ('x','y','z','t')
    END TYPE
-
-   INTEGER(i4), PARAMETER :: ip_maxdim = 4  !< number of dimension to be used
-
-   !  module variable
-   CHARACTER(LEN=lc), PARAMETER :: cp_dimorder = 'xyzt' !< dimension order to output
 
    INTERFACE dim_print
       MODULE PROCEDURE dim__print_unit ! print information on one dimension
-      MODULE PROCEDURE dim__print_tab  ! print information on a table of dimension
+      MODULE PROCEDURE dim__print_arr  ! print information on a array of dimension
    END INTERFACE dim_print
 
    INTERFACE dim_clean
       MODULE PROCEDURE dim__clean_unit ! clean one dimension
-      MODULE PROCEDURE dim__clean_tab  ! clean a table of dimension
+      MODULE PROCEDURE dim__clean_arr  ! clean a array of dimension
    END INTERFACE dim_clean
 
+   INTERFACE dim_copy
+      MODULE PROCEDURE dim__copy_unit  ! copy dimension structure
+      MODULE PROCEDURE dim__copy_arr   ! copy array of dimension structure
+   END INTERFACE
+
    INTERFACE dim_reshape_2xyzt
-      MODULE PROCEDURE dim__reshape_2xyzt_dp   ! reshape real(8) 4D table to ('x','y','z','t')
+      MODULE PROCEDURE dim__reshape_2xyzt_dp   ! reshape real(8) 4D array to ('x','y','z','t')
    END INTERFACE dim_reshape_2xyzt
 
    INTERFACE dim_reshape_xyzt2
-      MODULE PROCEDURE dim__reshape_xyzt2_dp   ! reshape real(8) 4D table from ('x','y','z','t')
+      MODULE PROCEDURE dim__reshape_xyzt2_dp   ! reshape real(8) 4D array from ('x','y','z','t')
    END INTERFACE dim_reshape_xyzt2
 
    INTERFACE dim_reorder_2xyzt
-      MODULE PROCEDURE dim__reorder_2xyzt_i4   ! reorder integer(4) 1D table to ('x','y','z','t')
-      MODULE PROCEDURE dim__reorder_2xyzt_c    ! reorder string 1D table to ('x','y','z','t')
-      MODULE PROCEDURE dim__reorder_2xyzt_l    ! reorder logical 1D table to ('x','y','z','t')
+      MODULE PROCEDURE dim__reorder_2xyzt_i4   ! reorder integer(4) 1D array to ('x','y','z','t')
+      MODULE PROCEDURE dim__reorder_2xyzt_c    ! reorder string 1D array to ('x','y','z','t')
+      MODULE PROCEDURE dim__reorder_2xyzt_l    ! reorder logical 1D array to ('x','y','z','t')
    END INTERFACE dim_reorder_2xyzt
 
    INTERFACE dim_reorder_xyzt2
-      MODULE PROCEDURE dim__reorder_xyzt2_i4   ! reorder integer(4) 1D table from ('x','y','z','t')
-      MODULE PROCEDURE dim__reorder_xyzt2_c    ! reorder string 1D table from ('x','y','z','t')
-      MODULE PROCEDURE dim__reorder_xyzt2_l    ! reorder logical 1D table from ('x','y','z','t')  
+      MODULE PROCEDURE dim__reorder_xyzt2_i4   ! reorder integer(4) 1D array from ('x','y','z','t')
+      MODULE PROCEDURE dim__reorder_xyzt2_c    ! reorder string 1D array from ('x','y','z','t')
+      MODULE PROCEDURE dim__reorder_xyzt2_l    ! reorder logical 1D array from ('x','y','z','t')  
    END INTERFACE dim_reorder_xyzt2
 
 CONTAINS
    !-------------------------------------------------------------------
-   !> @brief This function returns dimension id, in a table of dimension structure,
-   !> given dimension name, or short name.
-   !> only dimension used are checked.
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim   : dimension structure
-   !> @param[in] cd_name  : dimension name or short name
-   !> @param[in] cd_sname : dimension short name
-   !> @return dimension id
-   !-------------------------------------------------------------------
-   !> @code
-   INTEGER(i4) FUNCTION dim_get_id( td_dim, cd_name, cd_sname )
+   !> @brief
+   !> This subroutine copy a array of dimension structure in another one
+   !> @details 
+   !> see dim__copy_unit
+   !>
+   !> @warning do not use on the output of a function who create or read an
+   !> structure (ex: tl_dim=dim_copy(dim_init()) is forbidden).
+   !> This will create memory leaks.
+   !> @warning to avoid infinite loop, do not use any function inside 
+   !> this subroutine
+   !>
+   !> @author J.Paul
+   !> @date November, 2014 - Initial Version
+   !
+   !> @param[in] td_dim   array of dimension structure
+   !> @return copy of input array of dimension structure
+   !-------------------------------------------------------------------
+   FUNCTION dim__copy_arr( td_dim )
       IMPLICIT NONE
       ! Argument
-      TYPE(TDIM),       DIMENSION(:), INTENT(IN) :: td_dim
+      TYPE(TDIM), DIMENSION(:), INTENT(IN) :: td_dim
+      ! function
+      TYPE(TDIM), DIMENSION(SIZE(td_dim(:))) :: dim__copy_arr
+
+      ! local variable
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      DO ji=1,SIZE(td_dim(:))
+         dim__copy_arr(ji)=dim_copy(td_dim(ji))
+      ENDDO
+
+   END FUNCTION dim__copy_arr
+   !-------------------------------------------------------------------
+   !> @brief
+   !> This subroutine copy an dimension structure in another one
+   !> @details 
+   !> dummy function to get the same use for all structure
+   !>
+   !> @warning do not use on the output of a function who create or read an
+   !> structure (ex: tl_dim=dim_copy(dim_init()) is forbidden).
+   !> This will create memory leaks.
+   !> @warning to avoid infinite loop, do not use any function inside 
+   !> this subroutine
+   !>
+   !> @author J.Paul
+   !> @date November, 2014 - Initial Version
+   !>
+   !> @param[in] td_dim   dimension structure
+   !> @return copy of input dimension structure
+   !-------------------------------------------------------------------
+   FUNCTION dim__copy_unit( td_dim )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TDIM), INTENT(IN)  :: td_dim
+      ! function
+      TYPE(TDIM) :: dim__copy_unit
+
+      ! local variable
+      !----------------------------------------------------------------
+
+      dim__copy_unit=td_dim
+
+   END FUNCTION dim__copy_unit
+   !-------------------------------------------------------------------
+   !> @brief This function returns dimension index,
+   !> given dimension name or short name.
+   !>
+   !> @details
+   !> the function check dimension name, in the array of dimension structure.
+   !> dimension could be used or not.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !> @date September, 2014 - do not check if dimension used
+   !>
+   !> @param[in] td_dim    array of dimension structure
+   !> @param[in] cd_name   dimension name
+   !> @param[in] cd_sname  dimension short name
+   !> @return dimension index
+   !-------------------------------------------------------------------
+   INTEGER(i4) FUNCTION dim_get_index( td_dim, cd_name, cd_sname )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TDIM)      , DIMENSION(:), INTENT(IN) :: td_dim
       CHARACTER(LEN=*),               INTENT(IN) :: cd_name
       CHARACTER(LEN=*),               INTENT(IN), OPTIONAL :: cd_sname
@@ -222,5 +348,5 @@
       !----------------------------------------------------------------
       ! init
-      dim_get_id=0
+      dim_get_index=0
 
       il_ndim=SIZE(td_dim(:))
@@ -228,82 +354,71 @@
       ! look for dimension name
       cl_name=fct_lower(cd_name)
-      ! check if dimension is in table of dimension structure and used
+      ! check if dimension is in array of dimension structure
       jj=0
       DO ji=1,il_ndim
-         !IF( td_dim(ji)%l_use ) jj=jj+1
-
          cl_dim_name=fct_lower(td_dim(ji)%c_name)
-         IF( TRIM(cl_dim_name) == TRIM(cl_name) .AND. &
-         &   td_dim(ji)%l_use )THEN
-            dim_get_id=ji !jj
-            CALL logger_debug("GET ID: variable name "//&
-            &  TRIM(ADJUSTL(cd_name))//" already in file " )
-            EXIT
+         IF( TRIM(cl_dim_name) == TRIM(cl_name) )THEN
+             dim_get_index=ji
+             EXIT
          ENDIF
       ENDDO
 
       ! look for dimension short name
-      IF(  dim_get_id == 0 )THEN
+      IF(  dim_get_index == 0 )THEN
 
          cl_sname=fct_lower(cd_name)
-         ! check if dimension is in table of dimension structure and used
+         ! check if dimension is in array of dimension structure
          jj=0
          DO ji=1,il_ndim
-            IF( td_dim(ji)%l_use ) jj=jj+1
-            
             cl_dim_sname=fct_lower(td_dim(ji)%c_sname)
-            IF( (TRIM(cl_dim_sname) == TRIM(cl_sname) ).AND.&
-            &   td_dim(ji)%l_use )THEN
-               CALL logger_debug("GET ID: variable short name "//&
+            IF( (TRIM(cl_dim_sname) == TRIM(cl_sname) ) )THEN
+               CALL logger_debug("DIM GET INDEX: variable short name "//&
                &  TRIM(ADJUSTL(cd_name))//" already in file")
-               dim_get_id=jj
+               dim_get_index=ji
                EXIT
             ENDIF
          ENDDO
+
       ENDIF
 
       ! look for dimension short name
       IF( PRESENT(cd_sname) )THEN
-         IF(  dim_get_id == 0 )THEN
+         IF(  dim_get_index == 0 )THEN
 
             cl_sname=fct_lower(cd_sname)
-            ! check if dimension is in table of dimension structure and used
+            ! check if dimension is in array of dimension structure
             jj=0
             DO ji=1,il_ndim
-               IF( td_dim(ji)%l_use ) jj=jj+1
-               
                cl_dim_sname=fct_lower(td_dim(ji)%c_sname)
-               IF( (TRIM(cl_dim_sname) == TRIM(cl_sname) ).AND.&
-               &   td_dim(ji)%l_use )THEN
-                  CALL logger_debug("GET ID: variable short name "//&
+               IF( (TRIM(cl_dim_sname) == TRIM(cl_sname) ) )THEN
+                  CALL logger_debug("DIM GET INDEX: variable short name "//&
                   &  TRIM(ADJUSTL(cd_sname))//" already in file")
-                  dim_get_id=jj
+                  dim_get_index=ji
                   EXIT
                ENDIF
             ENDDO
+
          ENDIF
       ENDIF
 
-   END FUNCTION dim_get_id
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function returns dimension id, in a table of dimension structure,
-   !> given dimension name, or short name.
-   !> only dimension used are checked.
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim   : dimension structure
-   !> @param[in] cd_name  : dimension name or short name
-   !> @param[in] cd_sname : dimension short name
+   END FUNCTION dim_get_index
+   !-------------------------------------------------------------------
+   !> @brief This function returns dimension id, in a array of dimension structure,
+   !> given dimension name, or short name. 
+   !> @note only dimension used are checked.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] td_dim    dimension structure
+   !> @param[in] cd_name   dimension name or short name
+   !> @param[in] cd_sname  dimension short name
    !> @return dimension id
    !-------------------------------------------------------------------
-   !> @code
-   INTEGER(i4) FUNCTION dim_get_void_id( td_dim, cd_name, cd_sname )
+   INTEGER(i4) FUNCTION dim_get_id( td_dim, cd_name, cd_sname )
       IMPLICIT NONE
       ! Argument
       TYPE(TDIM),       DIMENSION(:), INTENT(IN) :: td_dim
-      CHARACTER(LEN=*),               INTENT(IN), OPTIONAL :: cd_name
+      CHARACTER(LEN=*),               INTENT(IN) :: cd_name
       CHARACTER(LEN=*),               INTENT(IN), OPTIONAL :: cd_sname
 
@@ -318,7 +433,8 @@
       ! loop indices
       INTEGER(i4) :: ji
+      INTEGER(i4) :: jj
       !----------------------------------------------------------------
       ! init
-      dim_get_void_id=0
+      dim_get_id=0
 
       il_ndim=SIZE(td_dim(:))
@@ -326,72 +442,75 @@
       ! look for dimension name
       cl_name=fct_lower(cd_name)
-      ! check if dimension is in table of dimension structure and used
+      ! check if dimension is in array of dimension structure and used
+      jj=0
       DO ji=1,il_ndim
-
          cl_dim_name=fct_lower(td_dim(ji)%c_name)
          IF( TRIM(cl_dim_name) == TRIM(cl_name) .AND. &
-         &   .NOT. td_dim(ji)%l_use )THEN
-            dim_get_void_id=ji
-            EXIT
+         &   td_dim(ji)%l_use )THEN
+            IF( td_dim(ji)%i_id /= 0 )THEN
+               dim_get_id=td_dim(ji)%i_id
+               EXIT
+            ENDIF
          ENDIF
       ENDDO
 
       ! look for dimension short name
-      IF(  dim_get_void_id == 0 )THEN
+      IF(  dim_get_id == 0 )THEN
 
          cl_sname=fct_lower(cd_name)
-         ! check if dimension is in table of dimension structure and used
+         ! check if dimension is in array of dimension structure and used
+         jj=0
          DO ji=1,il_ndim
-            
             cl_dim_sname=fct_lower(td_dim(ji)%c_sname)
             IF( (TRIM(cl_dim_sname) == TRIM(cl_sname) ).AND.&
-            &   .NOT. td_dim(ji)%l_use )THEN
-               dim_get_void_id=ji
-               EXIT
+            &   td_dim(ji)%l_use )THEN
+               IF( td_dim(ji)%i_id /= 0 )THEN
+                  dim_get_id=td_dim(ji)%i_id
+                  EXIT
+               ENDIF
             ENDIF
          ENDDO
+
       ENDIF
 
       ! look for dimension short name
       IF( PRESENT(cd_sname) )THEN
-         IF(  dim_get_void_id == 0 )THEN
+         IF(  dim_get_id == 0 )THEN
 
             cl_sname=fct_lower(cd_sname)
-            ! check if dimension is in table of dimension structure and used
+            ! check if dimension is in array of dimension structure and used
+            jj=0
             DO ji=1,il_ndim
-               
                cl_dim_sname=fct_lower(td_dim(ji)%c_sname)
                IF( (TRIM(cl_dim_sname) == TRIM(cl_sname) ).AND.&
-               &   .NOT. td_dim(ji)%l_use )THEN
-                  dim_get_void_id=ji
-                  EXIT
+               &   td_dim(ji)%l_use )THEN
+                  IF( td_dim(ji)%i_id /= 0 )THEN
+                     dim_get_id=td_dim(ji)%i_id
+                     EXIT
+                  ENDIF
                ENDIF
             ENDDO
+
          ENDIF
       ENDIF
 
-      IF( dim_get_void_id == 0 )THEN
-         DO ji=1,il_ndim
-            IF( .NOT. td_dim(ji)%l_use ) dim_get_void_id=ji
-         ENDDO
-      ENDIF
-
-   END FUNCTION dim_get_void_id
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This routine initialise a dimension structure with given 
-   !> arguments (name, length, etc).<br/> 
+   END FUNCTION dim_get_id
+   !-------------------------------------------------------------------
+   !> @brief This function initialize a dimension structure with given
+   !> name.<br/>
+   !> @details
+   !> Optionally length could be inform, as well as short name and if dimension
+   !> is unlimited or not.<br/>
    !> define dimension is supposed to be used.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_name : dimension name
-   !> @param[in] id_len : dimension length
-   !> @param[in] ld_uld : dimension unlimited
-   !> @param[in] cd_sname : dimension short name
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] cd_name   dimension name
+   !> @param[in] id_len    dimension length
+   !> @param[in] ld_uld    dimension unlimited
+   !> @param[in] cd_sname  dimension short name
    !> @return dimension structure
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TDIM) FUNCTION dim_init( cd_name, id_len, ld_uld, cd_sname)
       IMPLICIT NONE
@@ -413,10 +532,10 @@
       cl_name=fct_upper(cd_name)
 
-      CALL logger_info( &
+      CALL logger_debug( &
       &  " DIM INIT: dimension name: "//TRIM(cl_name) )
       dim_init%c_name=TRIM(ADJUSTL(cd_name))
 
       IF( PRESENT(id_len) )THEN
-         CALL logger_info( &
+         CALL logger_debug( &
          &  " DIM INIT: dimension length: "//fct_str(id_len) )
          dim_init%i_len=id_len
@@ -434,5 +553,5 @@
          &   TRIM(cl_sname) == 'z' .OR. & 
          &   TRIM(cl_sname) == 't' )THEN
-            CALL logger_info( &
+            CALL logger_debug( &
             &  " DIM INIT: dimension short name: "//TRIM(cd_sname) )
             dim_init%c_sname=TRIM(cd_sname)
@@ -452,8 +571,8 @@
             dim_init%c_sname='y'
          ELSEIF( TRIM(cl_name)== 'z' .OR. &
-         &   INDEX(cl_name,'depth')/=0 )THEN
+         &       INDEX(cl_name,'depth')/=0 )THEN
             dim_init%c_sname='z'
          ELSEIF( TRIM(cl_name)== 't' .OR. &
-         &   INDEX(cl_name,'time')/=0 )THEN
+         &       INDEX(cl_name,'time')/=0 )THEN
             dim_init%c_sname='t'
          ENDIF      
@@ -462,5 +581,5 @@
 
       IF( PRESENT(ld_uld) )THEN
-         CALL logger_info( &
+         CALL logger_debug( &
          &  " DIM INIT: unlimited dimension: "//fct_str(ld_uld) )
          dim_init%l_uld=ld_uld
@@ -471,16 +590,17 @@
       ENDIF
       
+      ! get dimension orderer index
+      dim_init%i_2xyzt=SCAN(TRIM(cp_dimorder),TRIM(dim_init%c_sname))
+
    END FUNCTION dim_init
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subrtoutine print dimension information 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim : table of dimension structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE dim__print_tab(td_dim)
+   !-------------------------------------------------------------------
+   !> @brief This subroutine print informations of an array of dimension. 
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] td_dim array of dimension structure
+   !-------------------------------------------------------------------
+   SUBROUTINE dim__print_arr(td_dim)
       IMPLICIT NONE
 
@@ -496,15 +616,13 @@
       ENDDO
 
-   END SUBROUTINE dim__print_tab
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subrtoutine print dimension information 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_dim : dimension structure
-   !-------------------------------------------------------------------
-   !> @code
+   END SUBROUTINE dim__print_arr
+   !-------------------------------------------------------------------
+   !> @brief This subrtoutine print dimension information. 
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !
+   !> @param[in] td_dim dimension structure
+   !-------------------------------------------------------------------
    SUBROUTINE dim__print_unit(td_dim)
       IMPLICIT NONE
@@ -512,5 +630,4 @@
       ! Argument      
       TYPE(TDIM), INTENT(IN) :: td_dim
-
       !----------------------------------------------------------------
 
